Redmine - Defect #33550

Per role visibility settings for spent time custom fields is not properly checked
2020-06-04 04:58 - Adrien Crivell

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Custom fields Estimated time: 0.00 hour
Target version: 41.2

Resolution: Fixed Affected version: 4.1.0
Description

The role visibility settings for spent time custom fields introduced by #31859 is completely ignored when editing an issue, eg on

/issues/123. So the custom field will incorrectly be shown for any roles.

It will only has an effect when creating/editing a spent time directly, eg on /issues/123/time_entries/new. In this case the custom field

will correctly only be shown for selected roles.

| would expect that spent time custom fields are shown/hidden coherently between the two pages.

Custom field configuration
The developer, on the left, see the custom field as expected.
The reporter, on the right, should not see the custom field, but he incorrectly sees it when editing an issue (bottom right).
https://www.redmine.org/issues/31859
This has been reproduced in production on 4.1.0, and also on a brand new, local Redmine installation with default data loaded.

Environment:

Redmine version 4.1.1.stable
Ruby version 2.5.1-p57 (2018-03-29) [x86_64-1linux—gnu]
Rails version 5.2.4.2
Environment production
Database adapter Mysql2
Mailer queue ActiveJob: :QueueAdapters: :AsyncAdapter
Mailer delivery smtp
SCM:
Git 2.17.1
Filesystem

Redmine plugins:
no plugin installed

Related issues:
Related to Redmine - Defect #35132: Custum field default value has no effect ... New

Associated revisions

Revision 20801 - 2021-03-16 00:32 - Go MAEDA

Do not display in issue edit page spent time custom fields not visible by the user (#33550).

Patch by Marius BALTEANU.

Revision 20802 - 2021-03-16 00:36 - Go MAEDA

Delete spent time custom field values not visible by the user after assignment (#33550).

Patch by Marius BALTEANU.

Revision 20807 - 2021-03-17 09:02 - Go MAEDA
Merged r20801 from trunk to 4.1-stable (#33550).

Revision 20808 - 2021-03-17 09:04 - Go MAEDA
Merged r20802 from trunk to 4.1-stable (#33550).

History

#1 - 2020-06-07 09:57 - Mischa The Evil

- Subject changed from Per role visibility settings for spent time custom fields is sometimes ignored to Per role visibility settings for spent time custom
fields is ignored on issue edit
- Affected version changed from 4.1.1 to 4.1.0

Looking at the code | think that this issue can be confirmed. Though, I'd first want to rule-out that during your tests any of the users 'Developer' and
especially 'Reporter' was accidentally designated as an administrator (please see the admin checkbox in the user settings).
Can you confirm this?

| don't know how good your Ruby on Rails skills are nor if you have a test environment at your disposal, but you can try-out this (preliminary, yet
untested) patch against source:/tags/4.1.1 (based on r18358):

app/views/issues/_edit.html.erb | 2 +-
1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/app/views/issues/_edit.html.erb b/app/views/issues/_edit.html.erb
index 35527773d..fa8486c54 100644
—-—— a/app/views/issues/_edit.html.erb
+++ b/app/views/issues/_edit.html.erb
@R -21,7 +21,7 Q@
</div>
</div>
<p><%= time_entry.text_field :comments, :size => 60 %$></p>
- <% @time_entry.custom_field_values.each do |value| %>
+ <% @time_entry.editable_custom_field_values.each do |value| %>
<p><%= custom_field_tag_with_label :time_entry, value %></p>
<% end %>
<% end %>

#2 - 2020-06-08 02:31 - Adrien Crivelli
- File users.png added
- File edit-is-correct-after-patch.png added

- File reporter-cannot-submit-time-after-patch.png added

| can confirm that those two users are not administrator:

Login First name Last name Email Administrator Created Last connection
admin Redmine Admin admin@example.net o 044062020 11:25 AM 020 11:26 AM
Developer Developer Developer admin@Developer.com MDEO 11:30 AM (&) Lock  fig Delete
Reporter Reporter Reporter admin@Reporter.com 04/06/2020 11:30 AM  04/06/2020 11:31 AM £ Lock fig Delete

And | can also confirm that the patch correctly hides the field for the reporter role when applied on top of r19780 (more recent than what you
suggested):

% Done | 0 % Edit

tog e reporter

Spent time Hours Activity | — Please select —

wogine developer

Spent time Hours Activity | — Please select —

Co;
Comment
My custom field * - Please select —
Notes
Notes

Edit || Preview | B | 1| U & L AR EREIELES |
Edit | P B I S C W mmw = = F F e

Unfortunately the reporter role cannot submit time spent anymore, because the custom field is correctly hidden, but is incorrectly still required during
validation. | expect required, but invisible custom fields to be entirely ignored during validation.

This seems to be in direct relation to my comment from last week #31954-6.
https://www.redmine.org/projects/redmine/repository/svn/entry/tags/4.1.1
Bug #1
#3 - 2020-06-09 05:34 - Mischa The Evil

- Assignee set to Mischa The Evil

Adrien, thanks for your quick and useful feedback.
I'll do some more testing later this week.

#4 - 2020-07-30 14:45 - Markus Boremski

Can confirm this defect on 4.1.1
Also can confirm that #33550#note-1 fixes this defect.

#5 - 2020-07-31 03:25 - Adrien Crivelli

Markus, | expeet experience that even with the patch, a role that do not see the custom field is not able to submit time spent anymore, even though he
should be able to. Can you also confirm that unexpected behavior ?

Mischa, did you have an opportunity to have a look at this ?

#6 - 2020-10-02 08:33 - Markus Boremski

Markus, | expect that even with the patch, a role that do not see the custom field is not able to submit time spent anymore, even though he
should be able to. Can you also confirm that unexpected behavior ?

We have one field that is required, but it has a default value.
The second field is not requiered and does not have a default value.
This works fine so far.

On our system | can not validate this behavior mentioned by #33550#note-2.
But it sounds logical to me that in case of a reqiered field without a default value there might be an issue with this patch.

#7 - 2020-10-02 10:40 - Adrien Crivelli

Indeed | should have mentioned that my custom field is required but does not have a default value. That might seems a bit unusual, but | feel our use
case is reasonable.

Our custom field is meant to select to which customers the time will be billed. Reporters should not be aware of that at all. So we'd like to hide the
field for them. On the other hand we want developers to select which customers to bill. It must be billed to someone, so it is required. And we want to
force the developers to make a deliberate choice. We cannot say "by default it will be billed to Customer A". So we cannot have a default value.

That makes sense to me. But maybe there's a different way to approach this.

Then you could say that in most cases the reporters probably would not need to log time. So we could live with the patch for a while. But that feels a
little bit inconsistent behavior. It's showing a form that can never be valid. Sounds like a bug to me, or at least a suboptimal situation.

#8 - 2020-12-06 02:17 - Marius BALTEANU
- Assignee changed from Mischa The Evil to Marius BALTEANU
Sorry for not saying anything on this, I'm going to take a look tomorrow on this.

#9 - 2020-12-06 02:17 - Marius BALTEANU
- Status changed from New to Confirmed

- Target version set to 4.1.2

#10 - 2020-12-06 02:28 - Marius BALTEANU

Adrien Crivelli wrote:

Markus, | expect that even with the patch, a role that do not see the custom field is not able to submit time spent anymore, even though he
should be able to. Can you also confirm that unexpected behavior ?

Yes, it's an unexpected behaviour. A custom field not visible for the user should not be required.

I've fixed the first issue (spent time custom field always visible in issue#edit), I'll continue to work on the second issue. In the meantime, I've assigned
this issue to 4.1.2 in order to deliver the fixes as soon as possible.

#11 - 2020-12-06 12:29 - Marius BALTEANU

- File 0002-Delete-spent-time-custom-field-values-not-visible-by.patch added
- File 0001-Do-not-display-in-issue-edit-page-spent-time-custom-.patch added
- Assignee deleted (Marius BALTEANU)

Here are two patches that should fix both issues.

e The first patch fixes the issue as Mischa proposed and add two tests to cover the case.

¢ The second patch is more delicate because | used another method to remove the custom fields which are not visible for the user. To be more
specific, | chose to delete the custom field values (not visible for the user) after the values are assigned. This was the only solution that | found
that didn't require more changes in the safe_attributes= method. What | tried as well is to set to set the TimeEntry.project (because it is required
for custom fields visibility), but | encountered some failing tests.

Adrien Besson, Markus Schlichting, can you test the fixes?

#12 - 2020-12-06 12:29 - Marius BALTEANU

- Subject changed from Per role visibility settings for spent time custom fields is ignored on issue edit to Per role visibility settings for spent time
custom fields is not properly checked

#13 - 2020-12-16 08:19 - Marius BALTEANU
- Assignee set to Jean-Philippe Lang

#14 - 2020-12-28 02:47 - Adrien Crivelli
- File missing-red-color-on-custom-fields.png added

- File working-custom-fields.png added

Thank you for the second patch. | applied both patches on top of 36b5¢3204891aa63ff24cf6da434170cdcfdad5e (r20693) successfully, and the
behavior is now as expected. Meaning a reporter, on the right, can log time even without submitting a value for the required, no-default and invisible
custom field.
| only noticed a small visual inconsistency when submitting an invalid form where custom fields are not highlighted in red like other fields. If you think
this is unrelated and should be addressed separately (I think it should be), I'll gladly submit a new issue.

€ 5 (C @ localhost:3000/time_entries
(1] « Activity cannot be blank
missing red colors

#15 - 2021-01-09 17:54 - Marius BALTEANU

Adrien Crivelli wrote:

| only noticed a small visual inconsistency when submitting an invalid form where custom fields are not highlighted in red like other fields. If you
think this is unrelated and should be addressed separately (I think it should be), I'll gladly submit a new issue.

Thanks Adrien for testing the fix. Please open a new issue for the inconsistency, | took a look and is not an easy fix.

#16 - 2021-01-09 20:38 - Marius BALTEANU
Marius BALTEANU wrote:
Adrien Crivelli wrote:
| only noticed a small visual inconsistency when submitting an invalid form where custom fields are not highlighted in red like other fields. If
you think this is unrelated and should be addressed separately (I think it should be), I'll gladly submit a new issue.

Thanks Adrien for testing the fix. Please open a new issue for the inconsistency, | took a look and is not an easy fix.

I've created the issue and I've added a fix for it, please see #34580.

#17 - 2021-03-14 10:20 - Marius BALTEANU
- Assignee changed from Jean-Philippe Lang to Go MAEDA

#18 - 2021-03-14 12:47 - Go MAEDA
- Assignee changed from Go MAEDA to Marius BALTEANU
test_get_edit_should_not_display_spent_time_custom_field_not_visible is defined twice in test/functional/issues_controller_test.rb.
Could you fix 0001-Do-not-display-in-issue-edit-page-spent-time-custom-.patch ?
#19 - 2021-03-15 22:27 - Marius BALTEANU
- File 0002-Delete-spent-time-custom-field-values-not-visible-by.patch added
- File 0001-Do-not-display-in-issue-edit-page-spent-time-custom-.patch added
- Assignee changed from Marius BALTEANU to Go MAEDA
Go MAEDA wrote:
test_get_edit_should_not_display_spent_time_custom_field_not_visible is defined twice in test/functional/issues_controller_test.rb.

Could you fix 0001-Do-not-display-in-issue-edit-page-spent-time-custom-.patch ?

Done.

#20 - 2021-03-15 22:27 - Marius BALTEANU
- File deleted (0001-Do-not-display-in-issue-edit-page-spent-time-custom-.patch)

#21 - 2021-03-15 22:27 - Marius BALTEANU
- File deleted (0002-Delete-spent-time-custom-field-values-not-visible-by.patch)

#22 - 2021-03-16 00:40 - Go MAEDA
- Status changed from Confirmed to Resolved

- Resolution set to Fixed
#23 - 2021-03-16 03:24 - Go MAEDA
The test fails in 4.1-stable branch. | have not found the cause yet.

$ bin/rails test test/functional/issues_controller_test.rb:4878
Run options: --seed 30553

# Running:
Ej
Failure:
IssuesControllerTest#test_get_edit_should_display_visible_spent_time_custom_field [/Users/maeda/redmines/4.1-s
table/test/functional/issues_controller_test.rb:4890]:
Expected exactly 1 element matching "#issue-form select.cf_10", found O0..
Expected: 1
Actual: O

bin/rails test test/functional/issues_controller_test.rb:4878

#24 - 2021-03-16 07:54 - Marius BALTEANU
| will take a look.

#25 - 2021-03-16 21:24 - Marius BALTEANU

r19690 unified custom fields classes on 4.2.0 and the class used to assert the element doesn't exist in older versions.

Please apply the following changes:

diff --git a/test/functional/issues_controller_test.rb b/test/functional/issues_controller_test.rb
index ff7c564ae..e%e0cc255 100644

——— a/test/functional/issues_controller_test.rb

+++ b/test/functional/issues_controller_test.rb

@@ -4887,7 +4887,7 @@ class IssuesControllerTest < Redmine::ControllerTest

assert_response :success
= assert_select '#issue-form select.cf_10', 1
+ assert_select '#issue-form select#time_entry_custom_field values_10', 1

end

def test_get_edit_should_not_display_spent_time_custom_field not_visible
@@ -4907,7 +4907,7 @@ class IssuesControllerTest < Redmine::ControllerTest

assert_response :success
= assert_select '#issue-form select.cf_10', 0
+ assert_select '#issue-form select.#time_entry_custom_field values_10', 0
end
Test passes after this change:
root@3d6d6070185e: /work# ruby test/functional/issues_controller_test.rb -n test_get_edit_should_display_visibl
e_spent_time_custom_field

Run options: -n test_get_edit_should_display_visible_spent_time_custom_field --seed 7576

# Running:

Finished in 2.137915s, 0.4677 runs/s, 0.9355 assertions/s.
1 runs, 2 assertions, 0 failures, 0 errors, 0 skips

#26 - 2021-03-17 09:04 - Go MAEDA

- Status changed from Resolved to Closed

Committed the patches. Thank you.

#27 - 2021-04-15 07:52 - Markus Boremski

Unfortunately with 4.1.2 we now have an issue regarding this fix.
If we set a default value and the reporting person is not able to edit the field, the default value has no effect.
Should | report a new issue?

#28 - 2021-04-15 08:05 - Marius BALTEANU
Markus Boremski wrote:
Unfortunately with 4.1.2 we now have an issue regarding this fix.

If we set a default value and the reporting person is not able to edit the field, the default value has no effect.
Should | report a new issue?

Yes, please. I'll try to catch the fix in the upcoming 4.1.3 which will be release at the end of this month.
#29 - 2021-04-20 07:46 - Markus Boremski
Done -> #35132

Could you please edit title if necessary and maybe link over here.
TY

#30 - 2021-04-20 14:12 - Bernhard Rohloff
- Related to Defect #35132: Custum field default value has no effect if field is inaccessible added
